function CalcCompMethData(opt)

% fichier de calcul pour l'exemple jouet...
% initialisation

if ~isfield(opt,'load_data_func'); error('data loading function missing load_data_func(opt,i)'); end
if ~isfield(opt,'get_filename_func'); error('filename function missing'); end


if ~isfield(opt,'filter'); opt.filter=[]; end
if ~isfield(opt,'nbloop'); opt.nbloop=1; end
if ~isfield(opt,'seed'); opt.seed=1; end
if ~isfield(opt,'sel'); opt.sel=0; end
if ~isfield(opt,'tosel'); opt.tosel=[0 0 1 1 0 0 0 1 0]; end
%% Params

%clear all

%adpath('h2m')
nbloop=opt.nbloop; % number of loops

if opt.sel==0
    opt.tosel=[0 0 0 0 0 0 0 0 0];
end

seed=opt.seed;
rand('seed',seed);
randn('seed',seed);

resfilename=['results/' opt.get_filename_func(opt)  '.mat'];
diafilename=['results/' opt.get_filename_func(opt)   '.log'];

nbclass=opt.nbclass;

diary(diafilename)
diary on


% methods parameters

f=opt.f;

options=opt.options;

options.f=f; % : legth of the filter

options.decy =opt.decy;%: y time shift...
%options.decy =0;%: y time shift...



cvalues=opt.cvalues;
sigmavalues=opt.sigmavalues;
regnorm2=opt.regnorm2;
regnorm12=opt.regnorm12;
nbgaussgmm=opt.nbgaussgmm;
filtercvalues=opt.filtercvalues;
gammavalues=opt.gammavalues;
%regnorm2=opt.regnorm2;



todo=opt.todo
% svm svmfilt wsvm ssvml2 hmm


%% loop!

%sigsvms={};
res_svm=[];
err_svm=[];
auc_svm=[];

for i=1:nbloop
    %i=1

    fprintf('Loop: %d\n',i)

    % génératiojn des données
    [X,Y,Xval,Yval,Xte,Yte]=opt.load_data_func(opt,i);

    if nbclass<3
        Y=2*Y-3;
        Yval=2*Yval-3;
        Yte=2*Yte-3;
    end

    d=size(X,2);


    options.F=[ones(f,d)/(f)];

    %options.F=zeros(f,d)/f; options.F(options.decy+1,:)=1;
    Fmavg=ones(f,d)/(f);

    if opt.sel

        sel=rand(size(Y))<opt.sel;
        selval=rand(size(Yval))<opt.sel;

        Xsel=X(sel,:); Ysel=Y(sel,:);
        Xselval=Xval(selval,:); Yselval=Yval(selval,:);
    end


    %% HMM parameters learning


    prior=GetMarkovPrior(Y);
    if nbclass>2
        transmat=GetMarkovTransitionMatrix(Y);
    else
        transmat=GetMarkovTransitionMatrix((Y+1)/2+1);
    end





    %% calcul pour le svm tout court

    if todo(1)~=0

        disp('SVM Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;

        if  ~isfield(opt,'nosigma')&&~strcmp(options.kernel,'linear')
            opts.params{2}='kerneloption';
            opts.values{2}=sigmavalues;
        end

        opts.learning=@svmclass2;
        opts.valmodels=@svmval2;
        opts.warmstart=@warmstart_svmclass2;

        opts.calc_final=0;


        if opt.tosel(1)&&opt.sel
            % validation
            [svm,optionssvm,LOGsvm]=validation_loop(Xsel,Ysel,Xval,Yval,options,opts);

            % final learning
            svm=svmclass2([Xsel;Xselval],[Ysel;Yselval],optionssvm);

        else

            % validation
            [svm,optionssvm,LOGsvm]=validation_loop(X,Y,Xval,Yval,options,opts);

            % final learning
            svm=svmclass2([X;Xval],[Y;Yval],optionssvm);

        end

        ypred=svmval2(Xte,svm);

        %test
        res_svm{i}=get_precision(Yte,ypred);
        err_svm(i)=res_svm{i}.err;

        auc_svm(i)=res_svm{i}.auc;

        m_err_svm=mean(err_svm);
        m_auc_svm=mean(auc_svm);
        std_err_svm=std(err_svm);



        % HMM decoding

        svm=svmtoproba([X;Xval],[Y;Yval],svm);
        yprob=psvmval2(Xte,svm);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        %err_svm_mm=sum(ymm~=Yte)/length(Yte);

        err_svm_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_svm_mm=mean(err_svm_mm);
        std_err_svm_mm=std(err_svm_mm);

        fprintf('| Err_SVM  | Auc_SVM  | Err_SVM_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_svm,m_auc_svm,m_err_svm_mm)


    end

    % test


    %% calcul pour le svm filtré

    if todo(2)~=0

        disp('SVMF Validation')


        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;

        if  ~isfield(opt,'nosigma')&&~strcmp(options.kernel,'linear')
            opts.params{2}='kerneloption';
            opts.values{2}=sigmavalues;
        end

        opts.learning=@svmclass2;
        opts.valmodels=@svmval2;
        opts.warmstart=@warmstart_svmclass2;

        opts.calc_final=0;


        if opt.tosel(2)&&opt.sel

            Xavg=mfilter(Fmavg,X,options.decy);
            Xavg=Xavg(sel,:);
            Xvalavg=mfilter(Fmavg,Xval,options.decy);
            Xvalavg=Xvalavg(selval,:);



            [svmf,optionssvmf,LOGsvmf]=validation_loop(Xavg,Ysel,mfilter(Fmavg,Xval,options.decy),Yval,options,opts);

            % final learning
            svmf=svmclass2([Xavg;Xvalavg],[Ysel;Yselval],optionssvmf);

            clear Xavg Xvalavg

        else

            [svmf,optionssvmf,LOGsvmf]=validation_loop(mfilter(Fmavg,X,options.decy),Y,mfilter(Fmavg,Xval,options.decy),Yval,options,opts);

            % final learning
            svmf=svmclass2(mfilter(Fmavg,[X;Xval],options.decy),[Y;Yval],optionssvmf);


        end

        ypred=svmval2(mfilter(Fmavg,Xte,options.decy),svmf);

        res_svmf{i}=get_precision(Yte,ypred);
        err_svmf(i)=res_svmf{i}.err;
        auc_svmf(i)=res_svmf{i}.auc;

        m_err_svmf=mean(err_svmf);
        m_auc_svmf=mean(auc_svmf);
        std_err_svmf=std(err_svmf);

        % HMM !!
        svmf=svmtoproba(mfilter(Fmavg,[X;Xval],options.decy),[Y;Yval],svmf);
        yprob=psvmval2(mfilter(Fmavg,Xte,options.decy),svmf);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_svmf_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_svmf_mm=mean(err_svmf_mm);
        std_err_svmf_mm=std(err_svmf_mm);

        fprintf('| Err_SVMF | Auc_SVMF | Err_SVM_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_svmf,m_auc_svmf,m_err_svmf_mm)

        if  ~isfield(opt,'nosigma')
            options.kerneloption=optionssvmf.kerneloption;
        end


    end

    %% calcul pour le FilterSVM

    if todo(3)~=0

        disp('FilterSVM Validation')


        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=filtercvalues;

        opts.params{2}='regnorm2';
        opts.values{2}=regnorm2;

        opts.learning=@filtersvmclass;
        opts.valmodels=@filtersvmval;
        opts.warmstart=[];
        opts.keeplog=1;

        opts.calc_final=0;

        if opt.tosel(3)&&opt.sel
            options.sel=sel;
        else
            options.sel=[];
        end


        [filtersvm,optionsfilter,LOGfilter{i}]=validation_loop(X,Y,Xval,Yval,options,opts);

        if opt.tosel(3)&&opt.sel optionsfilter.sel=[sel;selval]; end

        filtersvm=filtersvmclass([X;Xval],[Y;Yval],optionsfilter);

        ypred=filtersvmval(Xte,filtersvm);

        res_filter{i}=get_precision(Yte,ypred);
        err_filter(i)=res_filter{i}.err;
        auc_filter(i)=res_filter{i}.auc;

        m_err_filter=mean(err_filter);
        m_auc_filter=mean(auc_filter);
        std_auc_filter=std(auc_filter);

        % HMM !!
        filtersvm=filtersvmtoproba([X;Xval],[Y;Yval],filtersvm);
        yprob=pfiltersvmval(mfilter(filtersvm,Xte),filtersvm);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_filter_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_filter_mm=mean(err_filter_mm);
        std_err_filter_mm=std(err_filter_mm);

        fprintf('| Err_Filter  | Auc_Filter  | Err_Filter_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_filter,m_auc_filter,m_err_filter_mm)

    end


    %% calcul pour le FilterSVMSparse

    if todo(4)~=0

        disp('FilterSVMSparse Validation')


        options.verbose=0;
        options.regnorm2=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=filtercvalues;

        opts.params{2}='regnorm12';
        opts.values{2}=regnorm12;

        opts.learning=@filtersvmclass;
        opts.valmodels=@filtersvmval;
        opts.warmstart=[];
        opts.parallel=4;

        opts.calc_final=0;

        if opt.tosel(4)&&opt.sel
            options.sel=sel;
        else
            options.sel=[];
        end

        [filtersvms,optionsfilterss,LOGfilters]=validation_loop(X,Y,Xval,Yval,options,opts);

        if opt.tosel(4)&&opt.sel optionsfilterss.sel=[sel;selval]; end

        filtersvms=filtersvmclass([X;Xval],[Y;Yval],optionsfilterss);

        ypred=filtersvmval(Xte,filtersvms);

        res_filters{i}=get_precision(Yte,ypred);
        err_filters(i)=res_filters{i}.err;
        auc_filters(i)=res_filters{i}.auc;

        m_err_filters=mean(err_filters);
        m_auc_filters=mean(auc_filters);
        std_auc_filters=std(auc_filters);

        % HMM !!
        svm=filtersvmtoproba([X;Xval],[Y;Yval],filtersvms);
        yprob=pfiltersvmval(Xte,svm);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_filters_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_filters_mm=mean(err_filters_mm);
        std_err_filters_mm=std(err_filters_mm);

        fprintf('| Err_FilterS | Auc_FilterS | Err_FilterS_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_filters,m_auc_filters,m_err_filters_mm)

    end

    %% Calculs pour les GMM
    if todo(5)~=0

        disp('GMM Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='nbgauss';
        opts.values{1}=nbgaussgmm;


        opts.learning=@gmmclass;
        opts.valmodels=@gmmval;
        opts.warmstart=[];

        opts.calc_final=0;

        if opt.tosel(5)

            % validation
            [gmm,optionsgmm,LOGgmm]=validation_loop(Xsel,Ysel,Xval,Yval,opt.optionsgmm,opts);

            gmm=gmmclass([Xsel;Xselval],[Ysel;Yselval],optionsgmm);

        else

            % validation
            [gmm,optionsgmm,LOGgmm]=validation_loop(X,Y,Xval,Yval,opt.optionsgmm,opts);

            gmm=gmmclass([X;Xval],[Y;Yval],optionsgmm);

        end

        ypred=gmmval(Xte,gmm);

        %test
        res_gmm{i}=get_precision(Yte,ypred);
        err_gmm(i)=res_gmm{i}.err;
        auc_gmm(i)=res_gmm{i}.auc;

        m_err_gmm=mean(err_gmm);
        m_auc_gmm=mean(auc_gmm);
        std_err_gmm=std(err_gmm);



        % HMM decoding


        yprob=pgmmval(Xte,gmm);

        path = viterbi_path(prior, transmat, [yprob]');

        if opt.nbclass<3
            path=2*path-3;
        end
        ymm=(path)';
        err_gmm_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_gmm_mm=mean(err_gmm_mm);
        std_err_gmm_mm=std(err_gmm_mm);

        fprintf('| Err_GMM  | Auc_GMM  | Err_GMM_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_gmm,m_auc_gmm,m_err_gmm_mm)


    end


    %% Calculs pour FilterGMM
    if todo(6)~=0 && todo(3)~=0

        disp('FilterGMM Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='nbgauss';
        opts.values{1}=nbgaussgmm;


        opts.learning=@gmmclass;
        opts.valmodels=@gmmval;
        opts.warmstart=[];

        opts.calc_final=0;


        if opt.tosel(6)

            Xavg=mfilter(filtersvm,X);
            Xavg=Xavg(sel,:);
            Xvalavg=mfilter(filtersvm,Xval);
            Xvalavg=Xvalavg(selval,:);


            % validation
            [filtergmm,optionsfiltergmm,LOGfiltergmm]=validation_loop(Xavg,Ysel,Xval,Yval,opt.optionsgmm,opts);

            filtergmm=gmmclass(mfilter(filtersvm,[Xavg;Xvalavg]),[Ysel;Yselval],optionsfiltergmm);

            clear Xavg Xvalavg

        else
            % validation
            [filtergmm,optionsfiltergmm,LOGfiltergmm]=validation_loop(mfilter(filtersvm,X),Y,mfilter(filtersvm,Xval),Yval,opt.optionsgmm,opts);

            filtergmm=gmmclass(mfilter(filtersvm,[X;Xval]),[Y;Yval],optionsfiltergmm);

        end

        ypred=gmmval(mfilter(filtersvm,Xte),filtergmm);

        %test
        res_filtergmm{i}=get_precision(Yte,ypred);
        err_filtergmm(i)=res_filtergmm{i}.err;
        auc_filtergmm(i)=res_filtergmm{i}.auc;

        m_err_filtergmm=mean(err_filtergmm);
        m_auc_filtergmm=mean(auc_filtergmm);
        std_err_filtergmm=std(err_filtergmm);



        % HMM decoding


        yprob=pgmmval(mfilter(filtersvm,Xte),filtergmm);

        path = viterbi_path(prior, transmat, [yprob]');
        if opt.nbclass<3
            path=2*path-3;
        end
        ymm=(path)';

        err_filtergmm_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_filtergmm_mm=mean(err_filtergmm_mm);
        std_err_filtergmm_mm=std(err_filtergmm_mm);

        fprintf('| Err_FGMM | Auc_FGMM | Err_FGMM_MM|\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_filtergmm,m_auc_filtergmm,m_err_filtergmm_mm)


    end
    
    if opt.sel
        
            Xtde=time_delay_embedding(X,options);
            Xtde=Xtde(sel,:);
            Xtdeval=time_delay_embedding(Xval,options);
            Xtdeval=Xtdeval(selval,:);
        
    end


    %% Calculs pour tdesvm
    if todo(7)~=0


        disp('TDESVM Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;

        if  ~isfield(opt,'nosigma')&&~strcmp(options.kernel,'linear')
            opts.params{2}='kerneloption';
            opts.values{2}=sigmavalues;
        end

        opts.learning=@svmclass2;
        opts.valmodels=@svmval2;
        opts.warmstart=@warmstart_svmclass2;

        opts.calc_final=0;

        if opt.tosel(7)&&opt.sel
        [tdesvm,optionstdesvm,LOGtdesvm]=validation_loop(Xtde,Ysel,Xtdeval,Yselval,options,opts);

        tdesvm=svmclass2([Xtde;Xtdeval],[Ysel;Yselval],optionstdesvm);            
            
        else
        % validation
        [tdesvm,optionstdesvm,LOGtdesvm]=validation_loop(time_delay_embedding(X,options),Y,time_delay_embedding(Xval,options),Yval,options,opts);

        tdesvm=svmclass2(time_delay_embedding([X;Xval],options),[Y;Yval],optionstdesvm);
        
        end

        ypred=svmval2(time_delay_embedding(Xte,options),tdesvm);

        %test
        res_tdesvm{i}=get_precision(Yte,ypred);
        err_tdesvm(i)=res_tdesvm{i}.err;
        auc_tdesvm(i)=res_tdesvm{i}.auc;

        m_err_tdesvm=mean(err_tdesvm);
        m_auc_tdesvm=mean(auc_tdesvm);
        std_err_tdesvm=std(err_tdesvm);





        % HMM decoding

        tdesvm=svmtoproba(time_delay_embedding([X;Xval],options),[Y;Yval],tdesvm);
        yprob=psvmval2(time_delay_embedding(Xte,options),tdesvm);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_tdesvm_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_tdesvm_mm=mean(err_tdesvm_mm);
        std_err_tdesvm_mm=std(err_tdesvm_mm);

        fprintf('| ErrTDESVM| AucTDESVM| ErrTDESVM_MM|\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_tdesvm,m_auc_tdesvm,m_err_tdesvm_mm)
    end

    %% Calculs pour tdesvm avec adaptive
    if todo(8)~=0


        disp('TDEGMKL Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;


        %opts.params{2}='gamma';
        %opts.values{2}=gammavalues;

        opts.learning=@gmklclass;
        opts.valmodels=@gmklval;
        opts.warmstart=[];

        opts.calc_final=0;

        if opt.tosel(8)&&opt.sel
        [tdeas,optionstdeas,LOGtdeas]=validation_loop(Xtde,Ysel,Xtdeval,Yselval,options,opts);

        tdeas=gmklclass([Xtde;Xtdeval],[Ysel;Yselval],optionstdeas);            
            
        else
        % validation
        [tdeas,optionstdeas,LOGtdeas]=validation_loop(time_delay_embedding(X,options),Y,time_delay_embedding(Xval,options),Yval,options,opts);

        tdeas=gmklclass(time_delay_embedding([X;Xval],options),[Y;Yval],optionstdeas);
        
        end

        ypred=gmklval(time_delay_embedding(Xte,options),tdeas);

        %test
        res_tdegmkl{i}=get_precision(Yte,ypred);
        err_tdegmkl(i)=res_tdegmkl{i}.err;
        auc_tdegmkl(i)=res_tdegmkl{i}.auc;

        m_err_tdegmkl=mean(err_tdegmkl);
        m_auc_tdegmkl=mean(auc_tdegmkl);
        std_err_tdegmkl=std(err_tdegmkl);



        % HMM decoding

        tdeas=gmkltoproba(time_delay_embedding([X;Xval],options),[Y;Yval],tdeas);
        yprob=pgmklval(time_delay_embedding(Xte,options),tdeas);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_tdegmkl_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_tdegmkl_mm=mean(err_tdegmkl_mm);
        std_err_tdegmkl_mm=std(err_tdegmkl_mm);

        fprintf('| ErrTDEMKL| AucTDEMKL| ErrTDEMKL_MM|\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_tdegmkl,m_auc_tdegmkl,m_err_tdegmkl_mm)
    end

    %% Calculs pour linear svm avec group lasso
    if (todo(9)~=0)&&strcmp(options.kernel,'linear')


        disp('LG-SVM Validation')

        options.verbose=0;

        opts=[];

        % validation options
        opts.params{1}='C';
        opts.values{1}=cvalues;


        %opts.params{2}='gamma';
        %opts.values{2}=gammavalues;

        opts.learning=@lgroupsvmclass;
        opts.valmodels=@svmval2;
        opts.warmstart=[];

        opts.calc_final=0;


        groups=floor(1:1/f:d+1);
        groups=groups(1:end-1);

        options.groups=groups;%ones(10,1)%ones(10,1)%1:10
        options.nu=2;
        options.L0=1;

       if opt.tosel(8)&&opt.sel
        % validation
        [tdegroup,optionstdegroup,LOGtdegroup]=validation_loop(Xtde,Ysel,Xtdeval,Yselval,options,opts);

        tdegroup=lgroupsvmclass([Xtde;Xtdeval],[Ysel;Yselval],optionstdegroup);
        
       else
        % validation
        [tdegroup,optionstdegroup,LOGtdegroup]=validation_loop(time_delay_embedding(X,options),Y,time_delay_embedding(Xval,options),Yval,options,opts);

        tdegroup=lgroupsvmclass(time_delay_embedding([X;Xval],options),[Y;Yval],optionstdegroup);           
           
           
       end

        ypred=svmval2(time_delay_embedding(Xte,options),tdegroup);

        %test
        res_tdegroup{i}=get_precision(Yte,ypred);
        err_tdegroup(i)=res_tdegroup{i}.err;
        auc_tdegroup(i)=res_tdegroup{i}.auc;

        m_err_tdegroup=mean(err_tdegroup);
        m_auc_tdegroup=mean(auc_tdegroup);
        std_err_tdegroup=std(err_tdegroup);



        % HMM decoding

        tdegroup=svmtoproba(time_delay_embedding([X;Xval],options),[Y;Yval],tdegroup);
        yprob=psvmval2(time_delay_embedding(Xte,options),tdegroup);

        if opt.nbclass>2
            path = viterbi_path(prior, transmat, [yprob]');
        else
            path = viterbi_path(prior, transmat, [1-yprob yprob]');
            path=2*path-3;
        end
        ymm=(path)';

        err_tdegroup_mm(i)=sum(ymm~=Yte)/length(Yte);

        m_err_tdegroup_mm=mean(err_tdegroup_mm);
        std_err_tdegroup_mm=std(err_tdegroup_mm);

        fprintf('| ErrG-SVN | AucG-SVN | ErrG-SVN_MM |\n')
        fprintf('| %1.6f | %1.6f | %1.8f |\n',m_err_tdegroup,m_auc_tdegroup,m_err_tdegroup_mm)
    end



    %% test

    %sauvegarde dans un fichier
    save(resfilename)


end

if ~opt.todo(3) opt.todo(6)=0;end;

fprintf('|Method    |Test Error| AUC      |Error Vit.  |\n')
fprintf('-----------------------------------------------\n')
if opt.todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f | %1.8f |\n',m_err_svm,m_auc_svm,m_err_svm_mm); end
if opt.todo(2)~=0 fprintf('|SVMF      | %1.6f | %1.6f | %1.8f |\n',m_err_svmf,m_auc_svmf,m_err_svmf_mm); end
if opt.todo(3)~=0 fprintf('|FilterSVM | %1.6f | %1.6f | %1.8f |\n',m_err_filter,m_auc_filter,m_err_filter_mm); end
if opt.todo(4)~=0 fprintf('|FilterSVMS| %1.6f | %1.6f | %1.8f |\n',m_err_filters,m_auc_filters,m_err_filters_mm); end
if opt.todo(5)~=0 fprintf('|GMM       | %1.6f | %1.6f | %1.8f |\n',m_err_gmm,m_auc_gmm,m_err_gmm_mm); end
if opt.todo(6)~=0 fprintf('|FilterGMM | %1.6f | %1.6f | %1.8f |\n',m_err_filtergmm,m_auc_filtergmm,m_err_filtergmm_mm); end
if opt.todo(7)~=0 fprintf('|TDESVM    | %1.6f | %1.6f | %1.8f |\n',m_err_tdesvm,m_auc_tdesvm,m_err_tdesvm_mm); end
if opt.todo(8)~=0 fprintf('|TDEGMKL   | %1.6f | %1.6f | %1.8f |\n',m_err_tdegmkl,m_auc_tdegmkl,m_err_tdegmkl_mm); end
if opt.todo(9)~=0 fprintf('|GROUPSVM  | %1.6f | %1.6f | %1.8f |\n',m_err_tdegroup,m_auc_tdegroup,m_err_tdegroup_mm); end

%% calc
diary off

%% sauvegarde des résultats dan un fichier

clear x  xte X Y Xval Yval Xte Yte Xsel Ysel Xselval Yselval
save(resfilename)

end
