% calculs pour la figure de visu de précision selon le paramètre du noyau

%% initialisation

clear all

% validation parameters
opt.nbloop=10;

opt.nbrel=2;
opt.nbtot=10;
d=opt.nbtot;
opt.nbpts=[1000 1000 10000];

opt.noise=1;
opt.noiserand=0;


f=11;

opt.type=4;
opt.f=f;
opt.dephsigs=10;
opt.decy=round(opt.f/2);
opt.nbitermax=20;
opt.nosigma=1;


% params to validate

opt.cvalues=logspace(1,5,5);
opt.sigmavalues=logspace(-1,2,5);
opt.filtercvalues=logspace(2,4,5);
opt.regnorm2=logspace(-4,2,7);
opt.regnorm12=logspace(1,3,5);


opt.seed=1;

opt.todo=[1 1 1 0 0 0];



% classification parameters
options.f=f; % : legth of the filter

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

options.F=ones(f,d)/(f); %: initialisation of the filter
%options.F=zeros(f,d)/(f); %: initialisation of the filter
%options.F(options.decy,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =10 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-3];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=0;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
end

opt.options=options;


%sigmas=logspace(-1,2,10)% 5 10 20 30 40 50];
sigmas=logspace(-1,2,6)% 5 10 20 30 40 50];
%filename=  GetToyFilename(opt);


%% loop


for i=1:length(sigmas)
    opt.options.kerneloption=sigmas(i);
    opt.sigma=sigmas(i);
    listop{i}=opt;
    %listop{i}.sigma=sigmas(i);
end

matlabpool(4)

for i=1:length(sigmas)
   
    CalcToyResults(listop{i})
    
end

keyboard

%% getresults

getres.filename=@GetToyFilename;
getres.opt=opt;
getres.var=sigmas;
getres.varname='sigma';
getres.getvars={'m_err_svm','m_err_svmf','m_err_filter','m_err_svm_mm','m_err_svmf_mm','m_err_filter_mm'};

res=GetMultiresults(getres)

%% visu results

figure(1)

linew=2;
msize=14;

semilogx(res.sigma,[res.m_err_svm],'g+-','linewidth',linew,'Markersize',msize)
hold on
plot(res.sigma,[res.m_err_svmf],'r*-','linewidth',linew,'Markersize',msize)
plot(res.sigma,[ res.m_err_filter],'bo-','linewidth',linew,'Markersize',msize)


plot(res.sigma,[res.m_err_svm_mm],'g+--','linewidth',linew,'Markersize',msize)
plot(res.sigma,[res.m_err_svmf_mm],'r*--','linewidth',linew,'Markersize',msize)
plot(res.sigma,[ res.m_err_filter_mm],'bo--','linewidth',linew,'Markersize',msize)


hold off
%errorbar(repmat(nbtot',1,5),[err0' erravg' errssvm' errwsvm' errmarkov'],[serr0' serravg' serrssvm' serrwsvm' serrmarkov'])

set(gca,'FontSize',12) 
xlabel('kernel parameter')
ylim([0 0.55])
title({'Test error with different kernel parameter \sigma_k',' (nbtot=10, nbrel=2,\sigma_n=1)'},'FontSize',14) 
legend('SVM','Avg-SVM','KF-SVM','SVM-Vit','Avg-SVM-Vit','KF-SVM-Vit')




