% calculs pour la figure de visu de précision selon la taille

%% initialisation

clear all

% validation parameters
opt.nbloop=10;

opt.nbrel=2;
opt.nbtot=20;
d=opt.nbtot;
opt.nbpts=[1000 1000 10000];

opt.noise=3;
opt.noiserand=0;
opt.nbclass=2;

f=15;

opt.type=5;
opt.cmean=15;
opt.csigma=5;
opt.w=1e-3;
%opt.sigmanoisebf=3;
opt.keepswitch=1;
%opt.filter=ones(10,1);

opt.convsize=5;

opt.f=f;
opt.dephsigs=10;
opt.decy=round(opt.f/2);
opt.nbitermax=20;

opt.seed=2;


% SVM SVM_AVG FilterSVM SFilterSVM GMM FilterGMM TDE_SVM TDE_GMKL group-svm
% group-svm
%opt.todo=[1 1 1 1 1 1 1 1];
opt.todo=[1 1 1 1 1 1 1 0 0];


% FilterSVM parameters
options.f=f; % : legth of the filter

options.decy =floor(f/2);%: y time shift...
%options.decy =0;%: y time shift...

%options.F=ones(f,d)/(f); %: initialisation of the filter
options.F=zeros(f,d)/(f); %: initialisation of the filter
options.F(options.decy+1,:)=1;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =40 ;%: log informatioouns
options.stopvarx=[0];% : threshold for stopping on F changes
options.stopvarj=[1e-6];
options.usegolden=1;
options.goldensearch_deltmax=.01;
options.goldensearch_stepmax=1;
options.numericalprecision=1e-3;

linear=1;
if linear
    options.kernel='linear';
    options.kerneloption=1;
    options.C = 1e-3; %: C value for svm
    options.regnorm2=1e-2;%[2.25e-2];
    options.regnorm12=0e-3;%[2.25e-2];
    options.solver=3;
    options.use_cg=1;
else
    options.kernel='gaussian';
    options.kerneloption=1;
    options.C = 1e3; %: C value for svm
    options.regnorm2=1e2;%[2.25e-2];
    options.regnorm12=0e2;%[2.25e-2];
    options.solver=4;
    options.use_cg=1;
end

% GMM parameters
optionsgmm.nbgauss=[2];
optionsgmm.nbiterem=50;
optionsgmm.nbiterkmeans=20;
optionsgmm.verbose=0;



% options gmkl
options.kerneltype=1; % noyaux multiplicatifs


% params to validate

nbval=10;
nbvalfilter=5;

opt.cvalues=logspace(0,4,nbval);
opt.sigmavalues=logspace(-1,2,nbval);
opt.filtercvalues=logspace(0,5,nbvalfilter);
opt.regnorm2=logspace(1,3,nbvalfilter);
opt.regnorm12=logspace(1,3,nbvalfilter);
opt.gammavalues=logspace(-1,2,nbvalfilter);
opt.nbgaussgmm=[1:5];


opt.options=options;
opt.optionsgmm=optionsgmm;

filename=  GetToyFilename2(opt);

flength=[1 3 6 10 15];

%% compute

for i=1:length(flength)
    
    opt.convsize=flength(i);
    CalcToyResults(opt)
    
end

pause

cd results

%% getresults

getres.filename=@GetToyFilename2;
getres.opt=opt;
getres.var=flength;
getres.varname='convsize';
getres.getvars=getvarslist(opt,[1 0 1]);

res=GetMultiresults(getres)

%% visu results

figure(1)
clf
linew=2;
msize=10;

hold on

if opt.todo(1)~=0 ,plot(res.var,[res.m_err_svm],'x-','linewidth',linew,'Markersize',msize), end
if opt.todo(2)~=0 ,plot(res.var,[res.m_err_svmf],'b*-','linewidth',linew,'Markersize',msize), end
if opt.todo(3)~=0 ,plot(res.var,[res.m_err_filter],'ro-','linewidth',linew,'Markersize',msize), end
if opt.todo(4)~=0 ,plot(res.var,[res.m_err_filters],'r+-','linewidth',linew,'Markersize',msize), end
if opt.todo(5)~=0 ,plot(res.var,[res.m_err_gmm],'g-','linewidth',linew,'Markersize',msize); end
if opt.todo(6)~=0 ,plot(res.var,[res.m_err_filtergmm],'gs-','linewidth',linew,'Markersize',msize); end
if opt.todo(7)~=0 ,plot(res.var,[res.m_err_tdesvm],'c+:','linewidth',linew,'Markersize',msize); end
if opt.todo(8)~=0 ,plot(res.var,[res.m_err_tdegmkl],'m+-','linewidth',linew,'Markersize',msize); end
if opt.todo(9)~=0 ,plot(res.var,[res.m_err_tdegroup],'m+--','linewidth',linew,'Markersize',msize); end

hold off
%errorbar(repmat(nbtot',1,5),[err0' erravg' errssvm' errwsvm' errmarkov'],[serr0' serravg' serrssvm' serrwsvm' serrmarkov'])

set(gca,'FontSize',12) 
xlabel('Taille du filtre du bruit de convolution')
%xlabel('convolutionnal noise size')
ylim([0 0.55])
title({'Erreur de test pour différentes taille du bruit de convolution' ' pour un problème non linéaire'},'FontSize',14) 

%title({'Test error with different ' getres.varname ' value'},'FontSize',14) 
%legend('SVM','Avg-SVM','KF-SVM','SVM-Vit','Avg-SVM-Vit','KF-SVM-Vit')
legs={'SVM','SVMF','FilterSVM','SFilterSVM','GMM','FilterGMM','TDESVM','TDEgmkl','GROUP-SVM'};

legend(legs{logical(opt.todo(:))})

%% visu results vitervi

figure(1)
clf
linew=2;
msize=14;

hold on

if opt.todo(1)~=0 ,plot(res.var,[res.m_err_svm_mm],'k+-','linewidth',linew,'Markersize',msize), end
if opt.todo(2)~=0 ,plot(res.var,[res.m_err_svmf_mm],'b*-','linewidth',linew,'Markersize',msize), end
if opt.todo(3)~=0 ,plot(res.var,[res.m_err_filter_mm],'ro-','linewidth',linew,'Markersize',msize), end
if opt.todo(4)~=0 ,plot(res.var,[res.m_err_filters_mm],'r+-','linewidth',linew,'Markersize',msize), end
if opt.todo(5)~=0 ,plot(res.var,[res.m_err_gmm_mm],'y+-','linewidth',linew,'Markersize',msize); end
if opt.todo(6)~=0 ,plot(res.var,[res.m_err_filtergmm_mm],'g+-','linewidth',linew,'Markersize',msize); end
if opt.todo(7)~=0 ,plot(res.var,[res.m_err_tdesvm_mm],'c+-','linewidth',linew,'Markersize',msize); end
if opt.todo(8)~=0 ,plot(res.var,[res.m_err_tdegmkl_mm],'g+-','linewidth',linew,'Markersize',msize); end
if opt.todo(9)~=0 ,plot(res.var,[res.m_err_tdegroup_mm],'m+-','linewidth',linew,'Markersize',msize); end

hold off
%errorbar(repmat(nbtot',1,5),[err0' erravg' errssvm' errwsvm' errmarkov'],[serr0' serravg' serrssvm' serrwsvm' serrmarkov'])

set(gca,'FontSize',12) 
xlabel('convolutionnal noise size')
ylim([0 0.55])
title({'Test error with different ' getres.varname ' value'},'FontSize',14) 
%legend('SVM','Avg-SVM','KF-SVM','SVM-Vit','Avg-SVM-Vit','KF-SVM-Vit')
legs={'SVM','SVMF','FilterSVM','SFilterSVM','GMM','FilterGMM','TDESVM','TDEgmkl','GROUP-SVM'};

legend(legs{logical(opt.todo(:))})

%% loading file

numfile=5;
  opt.convsize=flength(numfile);
filename=  GetToyFilename2(opt);
load(['results/' filename '.mat'])

if opt.todo(1)~=0 res_svm=res_svm{1}; end
if opt.todo(2)~=0 res_svmf=res_svmf{1}; end
if opt.todo(3)~=0 res_filter=res_filter{1}; end
if opt.todo(4)~=0 res_filters=res_filters{1}; end
if opt.todo(5)~=0 res_gmm=res_gmm{1}; end
if opt.todo(6)~=0 res_filtergmm=res_filtergmm{1}; end
if opt.todo(7)~=0 res_tdesvm=res_tdesvm{1}; end
if opt.todo(8)~=0 res_tdegmkl=res_tdegmkl{1}; end
if opt.todo(9)~=0 res_tdegroup=res_tdegroup{1}; end

% print results
                                                   
                  fprintf('|Method    |Test Error| AUC      |Error Vit.  |\n')
                  fprintf('-----------------------------------------------\n')
if opt.todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f | %1.8f |\n',m_err_svm,m_auc_svm,m_err_svm_mm); end
if opt.todo(2)~=0 fprintf('|SVMF      | %1.6f | %1.6f | %1.8f |\n',m_err_svmf,m_auc_svmf,m_err_svmf_mm); end
if opt.todo(3)~=0 fprintf('|FilterSVM | %1.6f | %1.6f | %1.8f |\n',m_err_filter,m_auc_filter,m_err_filter_mm); end
if opt.todo(4)~=0 fprintf('|FilterSVMS| %1.6f | %1.6f | %1.8f |\n',m_err_filters,m_auc_filters,m_err_filters_mm); end
if opt.todo(5)~=0 fprintf('|GMM       | %1.6f | %1.6f | %1.8f |\n',m_err_gmm,m_auc_gmm,m_err_gmm_mm); end
if opt.todo(6)~=0 fprintf('|FilterGMM | %1.6f | %1.6f | %1.8f |\n',m_err_filtergmm,m_auc_filtergmm,m_err_filtergmm_mm); end
if opt.todo(7)~=0 fprintf('|TDESVM    | %1.6f | %1.6f | %1.8f |\n',m_err_tdesvm,m_auc_tdesvm,m_err_tdesvm_mm); end
if opt.todo(8)~=0 fprintf('|TDEGMKL   | %1.6f | %1.6f | %1.8f |\n',m_err_tdegmkl,m_auc_tdegmkl,m_err_tdegmkl_mm); end
if opt.todo(9)~=0 fprintf('|GROUPSVM  | %1.6f | %1.6f | %1.8f |\n',m_err_tdegroup,m_auc_tdegroup,m_err_tdegroup_mm); end


% visu AUC

figure(36)
clf
linew=2;
msize=14;
hold on;

if opt.todo(1)~=0 plot(res_svm.fpr,res_svm.tpr,'k','linewidth',linew,'Markersize',msize); end
if opt.todo(2)~=0 plot(res_svmf.fpr,res_svmf.tpr,'k--','linewidth',linew,'Markersize',msize);end

if opt.todo(3)~=0 plot(res_filter.fpr,res_filter.tpr,'b','linewidth',linew,'Markersize',msize); end
if opt.todo(4)~=0 plot(res_filters.fpr,res_filters.tpr,'b-.','linewidth',linew,'Markersize',msize); end
if opt.todo(5)~=0 plot(res_gmm.fpr,res_gmm.tpr,'g','linewidth',linew,'Markersize',msize); end
if opt.todo(6)~=0 plot(res_filtergmm.fpr,res_filtergmm.tpr,'b--','linewidth',linew,'Markersize',msize); end
if opt.todo(7)~=0 plot(res_tdesvm.fpr,res_tdesvm.tpr,'m','linewidth',linew,'Markersize',msize); end
if opt.todo(8)~=0 plot(res_tdegmkl.fpr,res_tdegmkl.tpr,'m:','linewidth',linew,'Markersize',msize); end
if opt.todo(9)~=0 plot(res_tdegroup.fpr,res_tdegroup.tpr,'m--','linewidth',linew,'Markersize',msize); end
hold off

title('AUC')

legs={'SVM','SVMF','FilterSVM','SFilterSVM','GMM','FilterGMM','TDESVM','TDEgmkl','GroupSVM'};

legend(legs{logical(todo(:))})
axis square

