% calculs pour la figure de visu de précision selon la taille

%% initialisation

clear all
addpath('../..')
opt.nbloop=10;

opt.nbrel=3;
opt.nbtot=3;
opt.nbpts=1000;

opt.noise=3;
opt.noiserand=0;

opt.f=21;
opt.dephsigs=20;
opt.decy=round(opt.f/2);
opt.nbitermax=20;

opt.nbreg2=5;
opt.nbregw=5;
opt.nbC=3;

opt.regnorm2=[-6 -4];
opt.regC=[-5 -3];
opt.regw=[2 4];


opt.seed=1;

opt.todo=[0 0 0 0 0 1];

filename=  GetToyFilename(opt);


%% loop

nbtot=[3 10 20 30 40 60 100];


for i=1:length(nbtot)
    
    opt.nbtot=nbtot(i);
    CalcToyResults(opt)
    
end


%% getresults


for i=1:length(nbtot)
    
    opt.nbtot=nbtot(i);
     filename=  GetToyFilename(opt);
     filename=filename(11:end);
   %  load(filename,'merr0','merravg','merrssvm','merrwsvm','merrmarkov');
     load([filename '.mat'],'merr0','merravg','merrssvm','merrwsvm','merrmarkov','stderr0','stderravg','stderrssvm','stderrwsvm','stderrmarkov');
     err0(i)=merr0;
     erravg(i)=merravg;
     errssvm(i)=merrssvm;
     errwsvm(i)=merrwsvm;
     errmarkov(i)=merrmarkov;
     serr0(i)=stderr0;
     serravg(i)=stderravg;
     serrssvm(i)=stderrssvm;
     serrwsvm(i)=stderrwsvm;
     serrmarkov(i)=stderrmarkov;
     
end


%% Visu



%figure(1)
subplot(1,2,2)


plot(nbtot,[err0'],'g+-')
hold on
plot(nbtot,[erravg' ],'r*-')
plot(nbtot,[ errssvm' ],'bo-')
plot(nbtot,[ errwsvm' ],'mx-')
plot(nbtot,[ errmarkov'],'cd-')
hold off
%errorbar(repmat(nbtot',1,5),[err0' erravg' errssvm' errwsvm' errmarkov'],[serr0' serravg' serrssvm' serrwsvm' serrmarkov'])


xlabel('nbtot')
ylim([0.03 .35 ])
title({'Test error with different ',' size nbtot (\sigma=3, nbrel=3)'}) 
%errorbar
legend('SVM','AVGSVM','SigSVM','WinSVM','HMM');
