function [X,Y,Xte,Yte]=GernerSig(nbpts,nbptste,nbclass,opts)
% opts.type: type of the switching models
%           1: sine freq switching (non linear)
% opts.params: params depending on the method...(1 line by class)
% opts.param : params for the complete signal
% opts.F     : frequency for the signal
% opts.csig  : sigma for the size of segments
% opts.cmean : mean for the size of segments

params=opts.params;
param=opts.param;
%nbchanges=opts.nbchanges;
csig=opts.csigma;
cmean=opts.cmean;

if isfield(opts,'F')
    F=opts.F;
else
    F=100;
end

if ~isfield(opts,'d')
    opts.d=1;
end

if ~isfield(opts,'dephsigs')
    opts.dephsigs=0;
end

if ~isfield(opts,'keepswitch')
    opts.keepswitch=0;
end

if ~isfield(opts,'filter')
    opts.filter=1;
end

if ~isfield(opts,'sigmanoisebf'); opts.sigmanoisebf=0; end

% vecteur de temps
t=(0:1:nbpts+nbptste-1)';

%création du vecteur des états

i=1;
id=[];
while (i<nbpts+nbptste)
    id=[id i];
    i=i+ceil(cmean+csig*(rand(1,1)-.5));
end



nbchanges=length(id);

id=[id nbpts+nbptste];

vals=ceil(nbclass.*rand(1,nbchanges));

for i=2:nbchanges
    if vals(i-1)==vals(i) && opts.keepswitch
        
        while vals(i-1)==vals(i)
            vals(i)=ceil(nbclass.*rand(1,1));
        end

    end
end

t=t/F;

Yt=zeros(nbpts+nbptste,1);
Ytmm=zeros(nbpts+nbptste,1);

if opts.type==4
    
    opts.d=1;
end

for i=1:nbchanges
    Yt(id(i):id(i+1))=vals(i);
end

Xf=zeros(nbpts+nbptste,opts.d);

for p=1:opts.d
    Xt=zeros(nbpts+nbptste,1);
    switch (opts.type)

        case 1 % 2 classes saut de moyenne...
            for i=1:nbchanges
                Xt(id(i):id(i+1))=params(vals(i),1)+params(vals(i),1+p)*randn(size(t(id(i):id(i+1))));
            end


        case 2 % 2 classes non linéaire


            vclasses=randperm(2*nbclass)-nbclass-1/2;
            for i=1:nbchanges
                idclass=  vals(i)*2-1 + floor(2*rand(1,1));
                Xt(id(i):id(i+1))=param*vclasses(idclass)+params(vals(i),2)*randn(size(t(id(i):id(i+1))));
                %Ytmm(id(i):id(i+1))=idclass;
            end
            vclasses=vclasses*param;

        case 3 % 2 classes saut moyenne non linéaire...
            for i=1:nbchanges
                Xt(id(i):id(i+1))=params(vals(i),1)+params(vals(i),1+p)*randn(size(t(id(i):id(i+1))));
            end


        case 4 % non linéaire
            for i=1:nbchanges


                if vals(i)==1
                    xtemp=(1-2*round(rand(1,1)))*[1 1];
                else
                    xtemp=(1-2*round(rand(1,1)))*[1 -1];
                end


                Xt(id(i):id(i+1),1:2)=repmat(xtemp,length(t(id(i):id(i+1))),1)+params(vals(1),2)*randn(length(t(id(i):id(i+1))),2);
                %Ytmm(id(i):id(i+1))=idclass;
            end

            p=1:2;

            if opts.dephsigs~=0

                tau=floor(opts.dephsigs*(rand(1)-.5));
                Xt(:,1)=DecalageSignalcycl(Xt(:,1),tau);
                tau=floor(opts.dephsigs*(rand(1)-.5));
                Xt(:,2)=DecalageSignalcycl(Xt(:,2),tau);
                opts.dephsigs=0;

            end

        case 5 % bruit convolutionnel

            

            for i=1:nbchanges
                Xt(id(i):id(i+1))=params(vals(i),1);
            end

            Xt=filter(opts.filter,[1],Xt)+params(vals(1),1+p)*randn(size(Xt));
            
            
        case 6 % bruit basse fréquence

            

            for i=1:nbchanges
                Xt(id(i):id(i+1))=params(vals(i),1)+params(vals(i),1+p)*randn(size(t(id(i):id(i+1))));
            end

            Xt=Xt+opts.sigmanoisebf*sin(opts.w*(1:size(Xt,1))');
            
        case 7
            
                  for i=1:nbchanges
                Xt(id(i):id(i+1))=opts.w7(vals(i));
                  end
                  
                  Xt=cos((1:(nbpts+nbptste))'.*Xt*2*pi);
            
                  Xt=Xt+params(vals(1),1+p)*randn(nbpts+nbptste,1);
                  
                  
        case 8 % non linéaire + convolution
            for i=1:nbchanges


                if vals(i)==1
                    xtemp=(1-2*round(rand(1,1)))*[1 1];
                else
                    xtemp=(1-2*round(rand(1,1)))*[1 -1];
                end


                Xt(id(i):id(i+1),1:2)=repmat(xtemp,length(t(id(i):id(i+1))),1);
                %params(vals(1),2)*randn(length(t(id(i):id(i+1))),2)
                %Ytmm(id(i):id(i+1))=idclass;
            end

            Xt=filter(opts.filter,[1],Xt)+params(vals(1),1+p)*randn(size(Xt));

            p=1:2;

            if opts.dephsigs~=0

                tau=floor(opts.dephsigs*(rand(1)-.5));
                Xt(:,1)=DecalageSignalcycl(Xt(:,1),tau);
                tau=floor(opts.dephsigs*(rand(1)-.5));
                Xt(:,2)=DecalageSignalcycl(Xt(:,2),tau);
                opts.dephsigs=0;

            end


    end
    Xf(:,p)=Xt;


    if opts.dephsigs~=0

        tau=floor(opts.dephsigs*(rand(1)-.5));
        Xf(:,p)=DecalageSignalcycl(Xf(:,p),tau);
    end
end



Y=Yt(1:nbpts,:);
Ymm=Ytmm(1:nbpts,:);
Yte=Yt(nbpts+1:nbpts+nbptste,:);
X=Xf(1:nbpts,:);;
Xte=Xf(nbpts+1:nbpts+nbptste,:);;

%vclasses=vclasses*param;


