function [xmin,dir,valmin,LOG]=get_svm_min(x0,dir,svm,options)
%  [xmin,LOG]=get_svm_min(x0,svm,options)
%  return the minimum or maximums for a given svm classifeurs
%
if ~isfield(options,'verbose'); options.verbose=0; end
if ~isfield(options,'log'); options.log=0; end
if ~isfield(options,'nbitermax'); options.nbitermax=50; end

if ~isfield(options,'numericalprecision'); options.numericalprecision=1e-15; end
if ~isfield(options,'use_cg'); options.use_cg=0; end
%if ~isfield(options,'dir'); options.dir=ones(size(x0,1),1); end
if ~isfield(options,'autodir'); options.autodir=0; end

if isempty(dir)
    options.autodir=1;
end

if options.autodir~=0
    dir=sign(svmval2(x0,svm));
end

nbpts=size(x0,1);

if nbpts>1
    
    for i=1:nbpts
    [xmin(i,:),valmin(i,:),LOG{i}]=get_svm_min(x0(i,:),dir(i),svm,options);
    end
    
else
  % LOG=struct;
   
    data.svm=svm;
    data.options=options;
    data.dir=dir;


    % solver options initialisation
            
        opts=options;
        

        opts.costfunc=@costfunc;
        opts.gradfunc=@gradfunc;
        %opts.printfunc=@printfunc;
        
          [xmin,vars,valmin,LOG]=grad_desc(x0,[],data,opts);
          valmin=-dir*valmin;
end



end


function [costnew,varsnew]=costfunc(x,data,vars)
% cost function for the non-linear case

%cost counter
global nbcall
nbcall=nbcall+1;

varsnew=vars;

costnew=-data.dir*svmval2(x,data.svm);

end

function [grad]=gradfunc(x,data,vars0)
% gradient function for the non-linear case


% cas gaussien
%temp=svmval2(data.svm.xsup,data.svm);

K=svmkernel(data.svm.xsup,data.svm.kernel,data.svm.kerneloption,x);

Xt=(repmat(x,size(data.svm.xsup,1),1)-data.svm.xsup).*repmat(K.*data.svm.w,1,size(x,2));

grad=data.dir*sum(Xt/data.svm.kerneloption);
end