/*

définition des noyaux...


 */

#include <math.h>
#include <stdio.h>
#include <stdarg.h>
#include "kernel_svm.h"



Kernel::Kernel(double * data,double *vals, int nb_pts, int nb_dim , int type_k, double * param)
{
  // initialization
  X=data;
  Y=vals;
  n=nb_pts;
  d=nb_dim;
  type=type_k;
  kerneloption=param;

  switch ( type) 
    {

  case KERNEL_GAUSSIAN : 
    // Process for test = 1
      hidden_kernel_calc= &(kernel_calc_gaussian);
      //kernel_calc_gaussian(int i, int j, double *X,int d, double *kerneloption)
    break;


  default : 
    //kernel_calc= &(kernel_calc_linear);
    hidden_kernel_calc= &(kernel_calc_linear);
    break;

    }



}

double Kernel::kernel_calc(int i, int j, void * autre)
{
  return hidden_kernel_calc( i, j, X,Y,n,d, kerneloption);
}


 
Kernel::~Kernel()
{
}


double kernel_calc_gaussian(int i, int j, double *X, double *Y,int n,int d, double *kerneloption)
{
  double res=0;
  double temp=0;

  for (int t=0;t<d;t++)
    {
      // temp += *(Y+i)**(Y+j)*(*(X+i+n*t)-*(X+j+n*t) )*(*(X+i+n*t)-*(X+j+n*t));
      temp +=(*(X+i+n*t)-*(X+j+n*t) )*(*(X+i+n*t)-*(X+j+n*t));
    }
  res= exp(-temp/ (2**(kerneloption)**(kerneloption)));

  return res;
  
}

double kernel_calc_linear(int i, int j, double *X, double *Y,int n,int d, double *kerneloption)
{
  double res=0;
  double temp=0;

  for (int t=0;t<d;t++)
    {
      temp += (*(X+i+n*t))*(*(X+j+n*t));
    }
  res=temp;

  return res;
  
}
