function [xsup,alpha,multiplier,pos,obj]=svmoneclassvapnik(x,kernel,kerneloption,c,verbose,alphainit)

% USAGE
%
% [xsup,alpha,rho,pos]=svmoneclass(x,kernel,kerneloption,nu,verbose)
%
% model f(x) = <w,x> - rho 
%
% problem solved 
% 
% min 1/2 <w,w>  + 1/nu/ell \sum_i \xi_i - rho
% st  <w,xi> - rho >= xi_i 
%
% the output is rho is actually - rho

if ~isempty(x)
[n1,n2]=size(x);
K=normalizekernel(x,kernel,kerneloption);
else
   
    K=kerneloption.matrix;
    n1=size(K,1);
end;

C= c;%1/nu/n1;
lambda=1e-8;
if nargin <6
    alphainit=C/2*ones(n1,1);
    alphainit=[];
else
    alphainit(find(alphainit>=C))=C;
end;


%nu=1-nu;

A=zeros(size(x,1),2*size(x,1)+1);
A(:,size(x,1)+1:end-1)=eye(size(x,1));
A(:,1:size(x,1))=K;
A(:,end)=-1;

f=ones(size(x,1),1);
f=[f;C.*ones(size(x,1),1);-1];


b=1*ones(size(x,1),1);


lp=zeros(2*size(x,1)+1,1); lp(end)=0;
up=C*ones(size(x,1)+1,1);up(size(x,1)+1:2*size(x,1)+1)=Inf;

%optim
temp=linprog(f,-A,-b,[],[],lp,up,'simplex','on');


alphall=temp(1:size(x,1));
xi=temp(size(x,1)+1:end-1);
d=temp(end);


%alphaall=zeros(size(e));
%alphaall(pos)=alpha;

pos=find(abs(alphall)>1e-6);
alpha=alphall(pos);

multiplier=d;

%e = ones(size(y));
obj=sum(alpha)+C*sum(xi)-d;

if ~isempty(x)
xsup=x(pos,:);
else
    xsup=[];
end;
Ksup=K(pos,pos);