

#include "mex.h"
#include "svqp2.h"
#include "kernel_svm.h"

/*
usage: [alphas]=svqp2_mex(X,Y,kernel_type,kerneloption,B,c_min,c_max,alphainit,sumflag)


 */

// global variable and function to get the value of the f***ing kernel
// (ISO C++)
Kernel * noyauglobal;

double kernel_calc(int i, int j, void *autre=NULL)
{
  return noyauglobal->kernel_calc(i,  j);
}

 void mexFunction(int nlhs, mxArray *plhs[], 
    int nrhs, const mxArray *prhs[])
{

if (nrhs<8)
 mexErrMsgTxt("Missing arguments");
 int verbose=0;


if (nlhs>3)
 mexErrMsgTxt("Only one output argument");

if (nrhs>7)
  {
    verbose=mxGetScalar(prhs[8]);
  }


 int n,d;

 //mexPrintf("SVQP2 Solver!!!\n");

 n = mxGetM(prhs[0]);
 d = mxGetN(prhs[0]);

 double *X=mxGetPr(prhs[0]);

 double *Y=mxGetPr(prhs[1]);

 int kernel_type=mxGetScalar(prhs[2]);

 double * kerneloption =  mxGetPr(prhs[3]);

 // get the parameters of the QP...
 double * b = mxGetPr(prhs[4]);
double * c_min = mxGetPr(prhs[5]);
double * c_max = mxGetPr(prhs[6]);
//bool sumflag = mxGetPr(prhs[78);
double * alphainit=mxGetPr(prhs[7]);

// // output...
// plhs[0]=mxDuplicateArray(plhs[8]);
plhs[0]=mxCreateDoubleMatrix(n,1,mxREAL);
plhs[1]=mxCreateDoubleMatrix(1,1,mxREAL);
plhs[2]=mxCreateDoubleMatrix(1,1,mxREAL);

double *alpha=mxGetPr(plhs[0]);
double *obj=mxGetPr(plhs[1]);
double *bias=mxGetPr(plhs[2]);


 Kernel noyau(X,Y,n,d,kernel_type,kerneloption);
 noyauglobal= &noyau;

 //mexPrintf("SVQP2 Solver!!!%f\n",noyau.kernel_calc(0,1));

  //double noyau.kernel_calc(0,1)

 int * aperm;
 //aperm= (int*)malloc(n*sizeof(int));



 // for (int i=0; i<n; i++)
 //   {
 // for (int j=0; j<n; j++)
 //   {
 //     *(alpha+i+n*j)=noyau.kernel_calc(i,j);
 //   }
 //   }

 SVQP2 solver(n);

 solver.Afunction=&kernel_calc;
 //solver.Aperm=aperm;
 solver.b=b;
 solver.cmin=c_min;
 solver.cmax=c_max;
 solver.maxcachesize=1024*2^20;


 for (int i=0; i<n; i++)
   {
     //  *(aperm+ i)=i;
      *(solver.x+i)=*(alphainit+i);
   }
 // solver.x=alpha;

 solver.verbosity=verbose;
 solver.run(1,1);

 for (int i=0; i<n; i++)
   {
     //  *(aperm+ i)=i;
      *(alpha+i)=*(solver.x+i);
   }

 *(obj)=solver.w;
 *(bias)=(solver.gmin+solver.gmax)/2;
 // mexPrintf("SVQP2 Solver!!!%f\n",  solver.Afunction(0,1,NULL));


 // solver.Afunction= 



 }
