%lassification 
%   Comparing Gaussian and polynomial Kernels 
%
%


clear all
close all

%%
%
%   Creating Data
%
seed=1985
rand('state',seed);
randn('state',seed);

nbapp=2000;
nn=20;
nbtest=nn*nn;
sigma=0.4;
[xapp,yapp,xtest,ytest,xtest1,xtest2]=datasets('checkers',nbapp,nbtest,sigma);
%------- Building a 2D Grid for function evaluation -------------------------
[xtest1 xtest2]  = meshgrid([-1:.05:1]*3.5,[-1:0.05:1]*3); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1)]; 

idxs=randperm(length(yapp));

yapp=yapp(idxs);
xapp=xapp(idxs,:);

nbnoise=0;
pbruit=1;
xapp=[xapp pbruit*randn(size(xapp,1),nbnoise)];
xtest=[xtest pbruit*zeros(size(xtest,1),nbnoise)];

%
%  learning with polynomial kernels
%



%% biclasse

options.lambda = 1e-10;  
options.C = 3e3;
options.kernel='gaussian';
options.kerneloption=.5;
options.verbose=0;
options.solver=4;
options.multiclass=0;

tic 
[svm,obj]=svmclass2(xapp,yapp,options)
toc

[ypred] = svmval2(xtest,svm);
ypred = reshape(ypred,nn,nn); 

%%

x0=[0,0]
dir=1;

nb=20;
x0=randn(nb,2);
dir=[];

optionsdesc.verbose= 1;%: print everything
optionsdesc.log =1;%: log informations
optionsdesc.nbitermax =40 ;%: log informatioouns
optionsdesc.stopvarx=[0];% : threshold for stopping on F changes
optionsdesc.stopvarj=[1e-6];
optionsdesc.goldensearch_deltmax=.001;
optionsdesc.goldensearch_stepmax=1;
optionsdesc.numericalprecision=1e-3;
optionsdesc.multiclass=0;
optionsdesc.linesearch=1;
optionsdesc.ls_tol=1e-3;


[x,dir,valmin,LOG]=get_svm_min(x0,dir,svm,optionsdesc)


%%
%
%               plotting
%

figure(1); 
clf; 
 h1=plot(xapp(yapp==1,1),xapp(yapp==1,2),'+r'); hold on
h2=plot(xapp(yapp==-1,1),xapp(yapp==-1,2),'+b');
contour(xtest1,xtest2,ypred);%,[-1 0 1]

h3=plot(svm.xsup(:,1),svm.xsup(:,2),'ok'); 



%%
%
%               plotting
%

figure(1); 
clf; 
 h1=plot(x(dir==1,1),x(dir==1,2),'+r'); hold on
h2=plot(x(dir==-1,1),x(dir==-1,2),'+b');
contour(xtest1,xtest2,ypred);%,[-1 0 1]


%%
%
%               plotting multiclass
%

figure(1); 
clf; 
vals=sort(unique(yapp),'ascend');

contourf(xtest1,xtest2,ypred);hold on
h1=plot(xapp(yapp==1,1),xapp(yapp==1,2),'+r'); 
h2=plot(xapp(yapp==2,1),xapp(yapp==2,2),'+b'); 
h2=plot(xapp(yapp==3,1),xapp(yapp==3,2),'+g'); 
h2=plot(xapp(yapp==4,1),xapp(yapp==4,2),'+c'); 


%-------------------  Gaussian Kernel -------------------
