function [ypredval,ypred]=drsvmval(X,sigsvm,opts)
% function returning  the labeling of a signal for a given signal svm
% decision function

if nargin<3
    opts=struct;
end

if ~isfield(opts,'sel'); options.sel=[]; end
if ~isfield(sigsvm,'r'); sigsvm.r=0; end
if ~isfield(sigsvm,'multiclass'); sigsvm.multiclass=0; end

if sigsvm.r==0

    if sigsvm.multiclass==0


        Xt=X*sigsvm.P;

        if isempty(sigsvm.xsup) && strcmp(sigsvm.kernel,'linear')
            y=lsvmval(Xt,sigsvm.w,sigsvm.w0);
        else
            y=svmval(Xt,sigsvm.xsup,sigsvm.w,sigsvm.w0,sigsvm.kernel,sigsvm.kerneloption,1);
        end

        %keyboard
        ypredval=y;
        % if ~isempty(opts.sel)
        %     ypredval=ypredval(opts.sel);
        % end
        ypred=sign(ypredval);

    else

        ypredval=zeros(size(X,1),sigsvm.nbclass);
        switch sigsvm.multiclass

            case 1 % one against all


                for i=1:sigsvm.nbclass

                    [ypredval(:,i)]=filtersvmval(X,sigsvm.models{i});


                end

                [temp,ypred]=max(ypredval,[],2);

        end

    end

else

    [ypredval,ypred]=rfiltersvmval(X,sigsvm);

end